;;; $Id: write.gsc,v 1.2 2015/03/05 05:35:21 lucier Exp lucier $ 
;;; Copyright (c) 1990-96 by Christian Queinnec, 2015 by Bradley Lucier. All rights reserved.

;;;                ***********************************************
;;;                    Small, Efficient and Innovative Class System
;;;                                    Meroon 
;;;                              Christian Queinnec  
;;;                    Ecole Polytechnique & INRIA--Rocquencourt
;;;                ************************************************

;;; A simple hook into Gambit's write system to display Meroon objects

(define (##wr-meroon we obj)
  (let* ((class
	  (object->class obj))
	 (fields
	  (Class-fields class))
	 (body
	  (map (lambda (field)
		 (if (Mono-Field? field)
		     (##list "Mono-Field: "
			     (Field-name field)
			     (if (field-defined? obj field)
				 (field-value obj field)
				 '<meroon-uninitialized>))
		     (let ((n (field-length obj field)))
		       (if (##real? n)
			   (do ((i 0 (##fx+ i 1))
				(result '() (##cons (if (field-defined? obj field i)
							(field-value obj field i)
							'<meroon-uninitialized>)
						    result)))
			       ((##fx= i n) (##append (##list "Poly-Field: " (Field-name field)) (##reverse result))))
			   (##list "Poly-Field: " (Field-name field) '<meroon-uninitialized>)))))
	       fields))
	 (obj
	  (##list->vector (##cons (Class-name class) body))))
    (##wr-vector-aux1 we obj (##vector-length obj) ##vector-ref '("#m<" . ">"))))
